// FormationData.cpp: implementation of the CFormationData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFormationData::CFormationData()
{
	InitializeFormations();
}

CFormationData::~CFormationData()
{
	TFormationMapIterator fmi = m_formations.begin();
	TFormationMapIterator fme = m_formations.end();

	for ( ; fmi != fme; fmi++ )
		delete (*fmi).second;

	m_formations.clear();
}

KPDL_RESULT CFormationData::InitializeFormations()
{
/*
	
	m_pFormation_433->SetPosition(f433_GOALIE, C2DVector(f433_GOALTENDERX,f433_CENTERY), f433_GOALIE_BUF, 
			     C2DVector(f433_GOALTENDERX,f433_CENTERY),
				 C2DVector(((m_pfield->GetFieldLength()/2.0)- (-f433_GOALTENDERX))*2,m_pfield->GetGoalSize()),   //SP_pitch_length
				 C2DVector(f433_GOALTENDERX,f433_CENTERY),
				 C2DVector(((m_pfield->GetFieldLength()/2.0)- (-f433_GOALTENDERX))*2,m_pfield->GetGoalSize()),   ///SP_goal_width
				 PT_Goaltender,PS_Center);
	
	m_pFormation_433->SetPosition(f433_SWEEPER, C2DVector(f433_SWEEPERX,f433_CENTERY), f433_POSITION_BUF, 
			     C2DVector(f433_SWEEPERX,f433_CENTERY),
				 C2DVector(((m_pfield->GetFieldLength()/2.0)- (-f433_SWEEPERX))*2,(m_pfield->GetPenaltyAreaWidth()/2.0)*2),
				 C2DVector(f433_SWEEPERX,f433_CENTERY),
				 C2DVector(-f433_SWEEPERX - (m_pfield->GetFieldLength()/2.0)/2,((m_pfield->GetFieldWidth()/2.0)+5)*2),
				 PT_Sweeper,PS_Center);
	
	m_pFormation_433->SetPosition(f433_RIGHT_DEFENSE, C2DVector(f433_DEFENDERX,f433_RIGHTY), f433_POSITION_BUF, 
			     C2DVector(f433_DEFENDERX,f433_RIGHTY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_DEFENDERX,f433_RIGHTY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Defender, PS_Right);
	
	m_pFormation_433->SetPosition(f433_CENTER_DEFENSE, C2DVector(f433_DEFENDERX+5,f433_CENTERY), f433_POSITION_BUF, 
			     C2DVector(f433_DEFENDERX+5,f433_CENTERY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_DEFENDERX+5,f433_CENTERY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Defender, PS_Center);
	
	m_pFormation_433->SetPosition(f433_LEFT_DEFENSE, C2DVector(f433_DEFENDERX,f433_LEFTY), f433_POSITION_BUF, 
			     C2DVector(f433_DEFENDERX,f433_LEFTY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_DEFENDERX,f433_LEFTY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Defender, PS_Left);
	
	m_pFormation_433->SetPosition(f433_RIGHT_MIDFIELD, C2DVector(f433_MIDFIELDERX,f433_RIGHTY), f433_POSITION_BUF, 
			     C2DVector(f433_MIDFIELDERX,f433_RIGHTY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_MIDFIELDERX,f433_RIGHTY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Midfielder, PS_Right);
	
	m_pFormation_433->SetPosition(f433_CENTER_MIDFIELD, C2DVector(f433_MIDFIELDERX,f433_CENTERY), f433_POSITION_BUF, 
			     C2DVector(f433_MIDFIELDERX,f433_CENTERY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_MIDFIELDERX,f433_CENTERY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Midfielder, PS_Center);
	
	m_pFormation_433->SetPosition(f433_LEFT_MIDFIELD, C2DVector(f433_MIDFIELDERX,f433_LEFTY), f433_POSITION_BUF, 
			     C2DVector(f433_MIDFIELDERX,f433_LEFTY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_MIDFIELDERX,f433_LEFTY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Midfielder, PS_Left);
	
	m_pFormation_433->SetPosition(f433_RIGHT_WING, C2DVector(f433_FORWARDX,f433_RIGHTY), f433_POSITION_BUF, 
			     C2DVector(f433_FORWARDX,f433_RIGHTY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_FORWARDX,f433_RIGHTY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Forward, PS_Right);
	
	m_pFormation_433->SetPosition(f433_CENTER_FORWARD, C2DVector(f433_FORWARDX+5,f433_CENTERY), f433_POSITION_BUF, 
			     C2DVector(f433_FORWARDX+5,f433_CENTERY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_FORWARDX+5,f433_CENTERY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Forward, PS_Center);
	
	m_pFormation_433->SetPosition(f433_LEFT_WING, C2DVector(f433_FORWARDX,f433_LEFTY), f433_POSITION_BUF, 
			     C2DVector(f433_FORWARDX,f433_LEFTY),
				 C2DVector(f433_HOMEXRANGE,f433_HOMEYRANGE),
				 C2DVector(f433_FORWARDX,f433_LEFTY),
				 C2DVector(f433_MAXXRANGE ,f433_MAXYRANGE),
				 PT_Forward, PS_Left);
	
*/

	// think positive :)
	KPDL_RESULT kpdlResult = KPDL_SUCCESS;
	
	IXMLDOMDocumentPtr pDom = NULL;
	IXMLDOMNodePtr pNode = NULL;
	IXMLDOMNodeListPtr pChildList = NULL;
	IXMLDOMNodePtr pChild = NULL;
	string sFileName = "formations.xml";

	_variant_t vFileName;
	_variant_t vRetVal;
	CFormation *pFormation;

	if(FAILED(CoInitializeEx(0, COINIT_MULTITHREADED)))
	{
		return KPDL_ERROR;
	}

	try
	{
		pDom.CreateInstance(DOM_DOCUMENT);
		vFileName = _bstr_t((LPCSTR)sFileName.c_str());
		vRetVal = pDom->load(vFileName);
		
		if(!(bool)vRetVal)
			return KPDL_ERROR;

		pNode = pDom->documentElement;
		pChildList = pNode->selectNodes(L"formation");
		pChildList->reset(); 

		while((pChild = pChildList->nextNode()) != NULL)
		{
			pFormation = new CFormation();
			pFormation->SetXML(pChild);
			
			m_formations.insert( TFormationMap::value_type( pFormation->GetName(), pFormation ) );
		}
	}
	catch(_com_error &E)
	{
		cSystemLog.Write(
			true, 
			"Chyba %08X pri nahravani suboru formacii '%s'",
			E.Error(),
			sFileName.c_str()
		);
		kpdlResult = KPDL_ERROR;
	}

	if(pChild != NULL)
		pChild.Release();

	if(pChildList != NULL)
		pChildList.Release();

	if(pNode != NULL)
		pNode.Release();

	if(pDom != NULL)
		pDom.Release();

	CoUninitialize();

	return kpdlResult;

}

CFormation *CFormationData::GetFormation(const string& formation)
{
	CFormation* pFormation = NULL;
	TFormationMapIterator fmi;

	fmi = m_formations.find( formation );
	if ( fmi != m_formations.end() )
		pFormation = m_formations[formation];

	return pFormation;
}