#ifndef FORMATIONS_H
#define FORMATIONS_H

//////////////////////////////////////////////////////////////////////////////////
//                        TeamPosition Class                                    
//////////////////////////////////////////////////////////////////////////////////

class CTeamPosition 
{
public:
	
	CTeamPosition();
	
	void SetHome(C2DVector p, float buf, Ptype t, Pside s);
	void SetHomeRange(C2DVector c, C2DVector s);
	void SetMaxRange (C2DVector c, C2DVector s);
	
	inline double GetHomeX()      { return m_Home.m_x;     }   
	inline double GetHomeY()      { return m_Home.m_y;     }	 
	inline C2DVector GetHome()       { return m_Home;       }   
	inline double GetHomeBuffer() { return m_dHomeBuffer; }	 
	
	inline RRectangle *GetHomeRange() { return &m_HomeRange; }  // vrat rozsah
	inline RRectangle *GetMaxRange()  { return &m_MaxRange;  }  // vrat max rozsah
	
	inline Ptype GetType() { return m_type; } // vrat typ hraca
	inline Pside GetSide() { return m_side; } // vrat stranu hraca
	
private:
	C2DVector m_Home;	// suradnice kde by sa mal hrac nachadzat
	double m_dHomeBuffer; // vzdialenost od Home
	
	RRectangle m_HomeRange; // rozsah v ktorom sa hrac moze nachadzat v ramci formacie
	RRectangle m_MaxRange; // maximalny rozsah - || -
	
	Ptype m_type;		// typ hraca, brankar, obranca, utocnik
	Pside m_side;		// strana hraca, lava, prava, stred 
};


class CFormation;

typedef map<string, CFormation*> TFormationMap;
typedef TFormationMap::iterator TFormationMapIterator;

//////////////////////////////////////////////////////////////////////////////////
//                             Formation Class                                    
//////////////////////////////////////////////////////////////////////////////////
class CFormation 
{
public:
	CFormation();
	~CFormation();
	
	inline int GetSize() { return m_size; }
	inline const string& GetName() { return m_name; }

	void SetPosition(Pnum num, C2DVector home, float buffer,
		C2DVector home_center, C2DVector home_size,
		C2DVector max_center,  C2DVector max_size,
		Ptype t, Pside s);
	
	CTeamPosition *GetPosition(Pnum num);
	
	bool IsMoreImportantPosition(Pnum pos1, Pnum pos2);
	
	Pnum   LocationToPosition(C2DVector p);
	double DistanceToPositionHome(Pnum position, C2DVector p);
	Pnum   ClosestPosition(C2DVector p);

	KPDL_RESULT SetXML(IXMLDOMNodePtr &pNode);	

private:
	string	m_name;
	long	m_size;
	
	CTeamPosition PositionList[MAX_PLAYERS]; 
	
};

#endif