// FormationSkills.cpp: implementation of the CFormationSkills class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CFormationSkills::CFormationSkills( CLocalAgent* pLocalAgent ) : m_LocalAgent ( pLocalAgent )
{

}

void CFormationSkills::SetFormation ( const string& formation )
{
	if ( m_LocalAgent )
		m_formation = m_LocalAgent->fdata->GetFormation(formation);
}

/*
void CFormationSkills::SetFormation(CLocalAgent *pa, Ftype f)
{
  pa->fdata->SetFormation(f);
}

Ftype CFormationSkills::GetActualFormation(CLocalAgent *pa)
{
   return pa->fdata->GetCurrentFormation()->GetType();
}
*/
C2DVector CFormationSkills::GetMyHomePosition()
{
	CLocalStaticField* fld = m_LocalAgent->field;
	double dFldLength, dFldWidth;
	C2DVector homePos;
	C2DVector retval;

	dFldLength = fld->GetFieldLength();
	dFldWidth = fld->GetFieldWidth();

	homePos = m_formation->GetPosition(m_LocalAgent->GetPlayerNumber())->GetHome();

	retval.SetXY( (dFldLength * homePos.GetX() - dFldLength)/2.0, dFldWidth * homePos.GetY() - dFldWidth/2.0);
    
	return retval;
}

double CFormationSkills::GetDistanceToFrontLine()
{
	CLocalStaticField* fld = m_LocalAgent->field;
	double dFldLength, dFldWidth;
	C2DVector homePos;
	double retval;

	dFldLength = fld->GetFieldLength();

	homePos = m_formation->GetPosition(m_LocalAgent->GetPlayerNumber())->GetHome();

	retval = (dFldLength * (1.0 - homePos.GetX()))/2.0;

	return retval;
}

/*
double CFormationSkills::GetMyHomeBuffer(CLocalAgent *pa)
{
    return m_formation->GetPosition(pa->GetPlayerNumber())->GetHomeBuffer();
}
*/
RRectangle *CFormationSkills::GetMyHomeRange()
{
    return m_formation->GetPosition(m_LocalAgent->GetPlayerNumber())->GetHomeRange();
}

Ptype CFormationSkills::GetActualPlayerType()
{
	return m_formation->GetPosition(m_LocalAgent->GetPlayerNumber())->GetType();
}

Pside CFormationSkills::GetActualPlayerSide()
{
	return m_formation->GetPosition(m_LocalAgent->GetPlayerNumber())->GetSide();
}
Pnum CFormationSkills::LocationToPosition(C2DVector p)
{
  return m_formation->LocationToPosition(p);
}

/*
void CFormationSkills::SetMyHomePosition(CLocalAgent *pa, C2DVector p, float buf, Ptype t, Pside s)
{
   pa->fdata->GetCurrentFormation()->GetPosition(pa->GetPlayerNumber())->SetHome(p, buf, t, s);
}

double CFormationSkills::GetMyHomeXPosition(CLocalAgent *pa)
{
    return pa->fdata->GetCurrentFormation()->GetPosition(pa->GetPlayerNumber())->GetHomeX();
}

double CFormationSkills::GetMyHomeYPosition(CLocalAgent *pa)
{
    return pa->fdata->GetCurrentFormation()->GetPosition(pa->GetPlayerNumber())->GetHomeY();
}


void CFormationSkills::SetMyHomeRange(CLocalAgent *pa, C2DVector c, C2DVector s)
{
	pa->fdata->GetCurrentFormation()->GetPosition(pa->GetPlayerNumber())->SetHomeRange(c,s);
}

RRectangle *CFormationSkills::GetMyMaxRange(CLocalAgent *pa)
{
    return pa->fdata->GetCurrentFormation()->GetPosition(pa->GetPlayerNumber())->GetMaxRange();
}

void CFormationSkills::SetMyMaxRange(CLocalAgent *pa, C2DVector c, C2DVector s)
{
	pa->fdata->GetCurrentFormation()->GetPosition(pa->GetPlayerNumber())->SetMaxRange(c,s);
}


// skillsy pre pracu s jednotkami
bool CFormationSkills::AmIUnitCaptain(CLocalAgent *pa, int unit, Pnum position)
{
   return pa->fdata->GetCurrentFormation()->IsUnitCaptain(unit, position);
}

bool CFormationSkills::AmIUnitMember(CLocalAgent *pa, int unit, Pnum position)
{
   return pa->fdata->GetCurrentFormation()->IsUnitMember(unit, position);
}

int CFormationSkills::GetNumOfUnits(CLocalAgent *pa)
{
   return pa->fdata->GetCurrentFormation()->GetNumUnits();
}

Utype CFormationSkills::GetUnitType(CLocalAgent *pa, int unit)
{ 
   return (pa->fdata->GetCurrentFormation()->GetUnit(unit))->GetType();
}

int CFormationSkills::GetMyUnitSize(CLocalAgent *pa, int unit)
{ 
   return (pa->fdata->GetCurrentFormation()->GetUnit(unit))->GetSize();
}

Pnum CFormationSkills::GetUnitCaptain(CLocalAgent *pa, int unit)
{
   return (pa->fdata->GetCurrentFormation()->GetUnit(unit))->GetCaptain();
}

Pnum *CFormationSkills::GetUnitMembers(CLocalAgent *pa, int unit)
{
   return (pa->fdata->GetCurrentFormation()->GetUnit(unit))->GetMembers();
}

Pnum CFormationSkills::MoreImportantPositionWithinUnit(CLocalAgent *pa, int unit, Pnum p1, Pnum p2)
{
   return (pa->fdata->GetCurrentFormation()->GetUnit(unit))->ImportantPosition(p1, p2);
}


Utype CFormationSkills::GetMyUnitType(CLocalAgent *pa, Pnum p)
{

   for (int i=0; i < pa->fdata->GetCurrentFormation()->GetNumUnits(); i++)
   {
	   if (pa->fdata->GetCurrentFormation()->IsUnitMember(i, p))
		 return (pa->fdata->GetCurrentFormation()->GetUnit(i))->GetType();
   }
 return UT_None;
}
*/

