#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define POWERRANGE(x)  (((x)>GetAgent()->cfg->maxpower)?GetAgent()->cfg->maxpower:             \
                        (((x)<GetAgent()->cfg->minpower)?GetAgent()->cfg->minpower:(x)))
#define MOMENTRANGE(x) (((x)>GetAgent()->cfg->maxmoment)?GetAgent()->cfg->maxmoment:           \
                        (((x)<GetAgent()->cfg->minmoment)?GetAgent()->cfg->minmoment:(x)))
#define NECKRANGE(x)   (((x)>GetAgent()->cfg->maxneckmoment)?GetAgent()->cfg->maxneckmoment:   \
                        (((x)<GetAgent()->cfg->minneckmoment)?GetAgent()->cfg->minneckmoment:(x)))

#define MINTURN  0.001

// FIXME: pre aku neurcitost sa pozerat za loptou
#define INVALID(diff, dist) ((((dist)>5) && ((diff)>(0.5*(dist)))) || (((dist)<5) && ((diff)>3)))
/////////////////////////////////////////////////////////////////////////////////////////////
CTurn::CTurn( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority   ) :CBasicSkill( BSKILL_MOVE, priority, pl ) 
{
	double posX = 0, posY = 0; m_accel = 0;
	m_accel = 0;
	TParameterBSkillsVectorIterator index = parameter.begin();
	m_skillSkillType = BSKILL_TURN_2;
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_ANGLE) 
				sscanf( index->value.data(), "%lf", &m_moment );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY ); 
	m_seeBall = -1;
}

void CTurn::Execute() 
{
	switch(	m_skillSkillType ) {
	case BSKILL_TURN_ME:
		Turn(m_dir);
		break;
	case BSKILL_TURN_TO:
		TurnTo(m_pos);
		break;
	case BSKILL_TURN_2:
		Turn2(m_moment);
		break;
	case BSKILL_TURN_TO_BALL:
		TurnToBall();
		break;
	}	
}

void CTurn::Turn(  double moment)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    double moment2 = RadToDeg(AngNormalise(moment));
    moment2 = MOMENTRANGE(moment2);  
    
    if ((moment2<-MINTURN) || (moment2>MINTURN)) {
        pGameCommand->Turn(moment2);
        GetAgent()->actionseq->AddGameCommand(pGameCommand);
    } else {
        delete pGameCommand;
    }
}

double CTurn::TurnWantedToReal(  double angle)
{
    return angle / (1.0 + GetAgent()->cfg->inertia_moment * GetAgent()->GetSpeed().GetDistance());
}

double CTurn::TurnRealToWanted(  double moment)
{
    return moment * (1.0 + GetAgent()->cfg->inertia_moment * GetAgent()->GetSpeed().GetDistance());
}

void CTurn::TurnTo(  C2DVector pos)
{
    Turn2( m_localSituation->RelVectorTo(GetAgent(), pos).GetAngle());
}

void CTurn::Turn2(double angle)
{
    Turn(TurnRealToWanted( angle));
}

///////////////////////////////////CTurnNeck///////////////////////////////////////////

CTurnNeck::CTurnNeck( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority   ) :CBasicSkill( BSKILL_MOVE, priority, pl ) 
{
	double posX = 0, posY = 0; m_accel = 0;
	m_accel = 0;
	TParameterBSkillsVectorIterator index = parameter.begin();
	m_skillSkillType = BSKILL_TURN_NECK_TO;
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_ANGLE) 
				sscanf( index->value.data(), "%lf", &m_moment );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY ); 
}

void CTurnNeck::Execute() 
{
	switch(	m_skillSkillType ) {
	case BSKILL_TURN_NECK_BASIC:
		TurnNeck(m_moment);
		break;
	case BSKILL_TURN_NECK_TO:
		TurnNeckTo(m_pos);
		break;
	case BSKILL_TURN_NECK_TO_BALL:
		TurnNeckToBall();
		break;
	case BSKILL_TURN_NECK_STRAIGHT:
		TurnNeckStraight();
		break;
	case BSKILL_TURN_NECK_FIND_BALL:
		TurnNeckFindBall();
	}	
}

void CTurnNeck::TurnNeckStraight( )
{
    double neckang =  GetAgent()->GetDirection() - GetAgent()->GetNeckDirection();
    if ((neckang < DegToRad(-1.0)) || (neckang > DegToRad(1.0))) TurnNeck(neckang);
}

void CTurnNeck::TurnNeckToBall( )
{
    CBall *pBall = GetAgent()->GetWorldModel()->GetBall();
    CDiffuse2DVector vball = pBall->GetPosition() - GetAgent()->GetPosition();
    double necktoball = vball.GetAngle() - GetAgent()->GetNeckDirection();
    TurnNeck( necktoball);
}


void CTurnNeck::TurnNeckTo(  C2DVector pos)
// FIXME: ak urobim turn, tak turnneckto sa musi od toho odpocitat!!!
// FIXME: bude treba urobit kontrolu ci sa mozem az tam otocit
//        a pripadne orezat, nech pri recompute nepocitam s blbostami
{
    C2DVector necktopos = Rot(pos - (C2DVector)GetAgent()->GetPosition(), -GetAgent()->GetNeckDirection());
    TurnNeck(necktopos.GetAngle());

//    double n = - ( GetAgent()->GetNeckDirection() - GetAgent()->GetDirection() );
//    double n = GetAgent()->GetDirection();

//    double n = RelVectorTo(GetAgent(), pos).GetAngle() - GetAgent()->GetDirection();
//    n += Rot(pos - (C2DVector)GetAgent()->GetPosition(), -GetAgent()->GetNeckDirection()).GetAngle();

//    n+=DegToRad(10);

//    TurnNeck(GetAgent(), n);
}

void CTurnNeck::TurnNeck(  double moment)
{
    CGameCommand *pGameCommand = new CGameCommand();    
    double moment2 = RadToDeg(AngNormalise(moment));  
    moment2 = NECKRANGE(moment2);  pGameCommand->TurnNeck(moment2);
    GetAgent()->actionseq->AddGameCommand(pGameCommand);
}


//******************************************************
/*! \fn	void CTurn::TurnToBall() 
 *  \brief Hladanie lopty
 *  \return
 *  \author Rado Otipka 
 *  \date 20.3.2002 18:07:28
 *  \bug 
 */
//******************************************************
// Historia zmien:
//******************************************************
/*
 */
//******************************************************
void CTurn::TurnToBall() 
{
	if (GetAgent()->GetTime().m_nPlayTime - GetAgent()->GetWorldModel()->GetBall()->m_cLastVisible.m_nPlayTime < 2) { 
			m_seeBall = -1;
			return;
	}
	C2DVector ballPos = GetAgent()->GetWorldModel()->GetBall()->GetPosition();
	C2DVector topos = m_localSituation->RelVectorTo(GetAgent(), ballPos);
	double ang = topos.GetAngle();
	if (m_seeBall==-1) {
		(ang>0) ? m_seeBall=0 : m_seeBall=1;
	}
//	cBSkillLog.Write(true,"Dotoc sa do lopty: %lf",ang);
	//zmen uhol pohladu ak potrebujes
	if (GetAgent()->GetVisualSettings() != VISUAL_RANGE_NORMAL)
		CChangeView(BSKILL_CHAGEVIEW_NOW ,VISUAL_RANGE_NORMAL, 1, GetAgent(), 0).Execute() ;
	if (GetAgent()->GetTime().m_nPlayTime - GetAgent()->GetWorldModel()->GetBall()->m_cLastVisible.m_nPlayTime > 3) { //tvrdarna
		//aky mas uhol pohladu, otoc sa o ten uhol, doprava
		double viewAngle = GetAgent()->GetViewAngle();
		if(m_seeBall == 1) if(m_seeBall == 1) viewAngle= -viewAngle;
		CTurn( BSKILL_TURN_2,viewAngle/3.0,GetAgent(),101 ).Execute();		
		GetAgent()->listSkl->AddSkill(new CTurn( BSKILL_TURN_TO_BALL,m_seeBall,GetAgent(),DEFAULT_PRIORITY));
		//ta 0.1 je koli tomu aby sa jednotlive pohldi aspon o nejaku hodnotu prekryvali
	} else {
		//ak je uhol otocenia voci lopte mensi ako 0.1 tak sa neotacaj
		if(fabs(ang) < 1.07.) return; 
		CTurn (BSKILL_TURN_2, ang, GetAgent(), 0).Execute();	
		return;	
	}
	return;	
	
}

#define MAX_TURN_NECK_MOMENT  180
#define MIN_TURN_NECK_MOMENT -180

void CTurnNeck::TurnNeckFindBall() 
{
	if (GetAgent()->GetTime().m_nPlayTime - GetAgent()->GetWorldModel()->GetBall()->m_cLastVisible.m_nPlayTime < 2) { 			
			TurnNeckStraight();			
			return;
	}
	if (GetAgent()->GetVisualSettings() != VISUAL_RANGE_NORMAL)
		CChangeView(BSKILL_CHAGEVIEW_NOW ,VISUAL_RANGE_NORMAL, 1, GetAgent(), 0).Execute() ;
	double viewAngle = GetAgent()->GetViewAngle();


/*	if(GetAgent()->GetNeckDirection() > (PI/2.0-0.3)) {
		TurnNeck(-PI);
	}

	if(GetAgent()->GetNeckDirection() < -(PI/2.0-0.3)) {
		TurnNeck(PI);
	}*/

} 