// ParameterQuery.cpp: implementation of the CParameterQuery class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CParameterQuery::CParameterQuery(CLocalAgent *pAgent)
:	CQuery()
{
	AddTerm(new CBestLocatedTeamMateTerm(pAgent));
	AddTerm(new CFreePositionTerm(pAgent));
	AddTerm(new CBestLocationForPassTerm(pAgent));
	AddTerm(new CActionPositionTerm(pAgent));
	AddTerm(new CStrategicPositionTerm(pAgent));
	AddTerm(new CBallInterceptPositionTerm(pAgent));
	AddTerm(new CBallPositionTerm(pAgent));
	AddTerm(new CGoalTerm(pAgent));
}

string CBestLocatedTeamMateTerm::Evaluate()
{
	return "1";
}

string CFreePositionTerm::Evaluate()
{
	return "0.0 0.0";
}

string CBestLocationForPassTerm::Evaluate()
{
	return "0.0 0.0";
}

string CActionPositionTerm::Evaluate()
{
	C2DVector& v = m_pAgent->field->GetGoal(GT_OPPONENT);
	string tmps;
	char buf[100];
	sprintf(buf, "%lf %lf", (v.GetX() - 15.0), v.GetY());
	tmps = buf;

	return tmps;
}

string CStrategicPositionTerm::Evaluate()
{
	//C2DVector& v = m_pAgent->field->GetGoal(GT_OPPONENT);
	C2DVector& v = m_pAgent->fskl->GetMyHomePosition();
	string tmps;
	char buf[100];
	string sFrontLine;
	double dFrontLine, homeX;

	double dFrontLineDist = m_pAgent->fskl->GetDistanceToFrontLine();

	m_pAgent->strategicSkills->Variable( "frontLine", sFrontLine );
	dFrontLine = atof( sFrontLine.c_str() );

	if ( dFrontLine > 0.0 )
		homeX = v.GetX() + dFrontLine;
	else
		homeX = v.GetX();
	
	sprintf(buf, "%lf %lf", homeX, v.GetY());
	tmps = buf;

	return tmps;
}

string CBallInterceptPositionTerm::Evaluate()
{
	return "0.0 0.0";
}

 // Rado Otipka 16. 12. 2001 11:09:09
string CBallPositionTerm::Evaluate()
{
	C2DVector v = m_pAgent->GetWorldModel()->GetBall()->GetPosition();
	string tmps;
	char buf[100];
	sprintf(buf, "%lf %lf", v.GetX(), v.GetY());
	tmps = buf;
	return tmps;
}

string CGoalTerm::Evaluate()
{
	C2DVector& v = m_pAgent->field->GetGoal(GT_OPPONENT);
	string tmps;
	char buf[100];
	sprintf(buf, "%lf %lf", v.GetX(), v.GetY());
	tmps = buf;

	return tmps;
}
